#include "mv.hh"
#include "TimeMeter.hh"
#include <iostream>

using namespace std ;

typedef float valueType ; // alias of double to valueType

int
main() {

  cout << "Size of valueType = " << sizeof( valueType ) << '\n' ;


  int N = 5 ;

  Vec<valueType> a(10), b(10), c(10) ;
  Mat<valueType> A(N,N), B(N,N), C(N,N) ;
  
  TimeMeter tm ;

  A.fill_random() ;
  B.fill_random() ;
  a.fill_random() ;
  b.fill_random() ;
  c.fill_random() ;

  {
    Vec<valueType> tmp(10) ;
    tmp.fill_random() ;
    a = tmp ;
    b = tmp ;
    cout << "Vector a (copied) = " << a << '\n' ; 
    cout << "Vector b (copied) = " << a << '\n' ; 
  }
  a.fill_random() ;

  cout << "Vector a = " << a << '\n' ; 
  cout << "Vector b = " << b << '\n' ; 

  cout << "Vector c = " << c << '\n' ;

  Vec<double> d = a ; // +b ;
  cout << "Vector d = a+b = " << d << '\n' ;
  
  cout << "Matrix A = " << A << '\n' ; 
 
}
